// btm2tad version 0.100
//  BTMemoΥե뷲TADľС 
// (C)Copyright 2003, Yashiro Takeshi

// Btm2TAD.cc : ץꥱΥᥤ󥯥饹

#include <basic.h>
#include <tcode.h>
#include <errcode.h>
#include <btron/btron.h>
#include <btron/vobj.h>
#include <tstring.h>
//#include <bsyslog.h>
#include <stdio.h>

#include <iostream>

#include "Btm2TAD.h"
#include "BtmSegment.h"
#include "TADSegment.h"

static B txed_fsn[128] = {0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 16, 0, 0, 0, 16, 255, 255, 255, 16, 4, 0, 0, 128, 3, 0, 0, 128, 112, 52, 92, 75, 56, 74, 79, 62, 84, 74, 56, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 74, 79, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 2, 8, 0, 0, 7, 0, 2, 0, 133, 2, 250, 1, 0, 0, 0, 0, 0, 0, 106, 2, 0, 0, 255, 255, 255, 16, 0, 0, 0, 0, 0, 0};
static B dled_fsn[128] = {0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 16, 0, 0, 0, 16, 255, 255, 255, 16, 4, 0, 0, 128, 1, 0, 0, 128, 62, 50, 72, 63, 108, 48, 119, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 48, 119, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 32, 0, 32, 0, 96, 1, 136, 1, 0, 0, 0, 0, 16, 0, 16, 0, 4, 0, 255, 255, 255, 16, 0, 0, 0, 0, 0, 0};

Btm2TAD::Btm2TAD(LINK *link)
{
  src = link;
  dest = new LINK;
  // ʲȥ졼ط
  setrect(tray_cnt.vseg.view, 0, 0, 160, 16);
  tray_cnt.vseg.chsz = 16;
  tray_cnt.vseg.height = 0;
  tray_cnt.vseg.frcol = tray_cnt.vseg.chcol = 0x10000000;
  tray_cnt.vseg.tbcol = tray_cnt.vseg.bgcol = 0x10ffffff;
  tray_cnt.vseg.dlen = 0;
  tray.id = TR_VOBJ;
  tray.len = sizeof(TR_VOBJREC) + tray_cnt.vseg.dlen;
  tray.dt = (B*)&tray_cnt;
}

Btm2TAD::~Btm2TAD()
{
  delete dest;
}

int Btm2TAD::run()
{
  /*
  BtmSegmentInfoSegment bs;
  bs.len = 60;
  TADSegment *ts = bs.createTADSegment(0);
  delete ts;
  return 0;
  */
  
  W srcFD, destFD, eachFD, num, werr, type;
  W err = 0;
  UH subtype;
  W rsize;
  LINK link;
  
  pdsp_msg((TC[]){L"ѴǤФ餯Ԥ"});
  setpointer(PS_BUSY, NULL);
  
  TC name[] = {L""};
  
  srcFD = opn_fil(src, F_READ, NULL);
  *dest = *src;
  destFD = cre_fil(dest, name, NULL, 6, F_FLOAT);
  copyLinkAttr(src, dest); // cre_fil°ǡ0ˤʤ뤿
  
  // (1) TADȤȼ¹Եǽ䵤ΤϤĤ
  copyTADSegment(srcFD, destFD);
  apd_rec(destFD, dled_fsn, 128, RT_MFUSEN, 0, 0);
  
  // (2) ƥ󥯥Ȥκ
  see_rec(srcFD, 0, 1, NULL); // Ƭ쥳ɤذư
  bool first = true;
  
  do {
    eachFD = fnd_rec(srcFD, (first ? F_FWD : F_NFWD), RM_LINK, 0, &num);
    
    if (eachFD >= 0){
      type = rea_rec(srcFD, 0, (B*)&link, sizeof(LINK), &rsize, &subtype);
      LINK *tadlnk = parseBtmFile(&link);
      if (tadlnk != 0){
        apd_rec(destFD, (B*)tadlnk, sizeof(LINK), type, subtype, 0);
        // ְäƤ 'delete tadlnk' Ϥʤ!
      }
    }
    
    first = false;
  } while (eachFD >= 0);
  
  cls_fil(srcFD);
  cls_fil(destFD);
  
  //srcFD = opn_fil(src, F_UPDATE, NULL);
  //apd_rec(srcFD, (B*)dest, sizeof(LINK), RT_LINK, 0, 0);
  //cls_fil(srcFD);
  tray_cnt.vlnk = *((VLINK*)dest);
  
  werr = tpsh_dat(&tray, 1, (TC[]){L""});
  //printf("tray: %d", werr);
  setpointer(PS_SELECT, NULL);
  pdsp_msg((TC[]){L"Ѵλޤ̤ϥȥ졼Ƥޤ"});
  return err;
}

LINK* Btm2TAD::parseBtmFile(LINK *link)
{
  W btmFD, tadFD, werr, type, fid;
  TC tname[21];
  char cname[42];
  LINK outlink;
  LINK *retlink = 0; // ֤(LINKĥ꤬ǹԤ)
  std::map<std::string, LINK>::iterator p;
  
  btmFD = opn_fil(link, F_READ, NULL);
  fil_sts(link, tname, NULL, NULL);
  trimPathAndExt(tname);
  tcstoeucs((B*)cname, tname);
  
  p = fileLink.find(cname);
  if (p != fileLink.end()){
    // ˥ե뤬ƤϤ
    tadFD = opn_fil(&(p->second), F_UPDATE, NULL);
    retlink = &(p->second); // LINKĥϸǹԤ롣
    outlink = p->second;
  }
  else {
    outlink = *dest;
    tadFD = cre_fil(&outlink, tname, NULL, 1, F_FIX);
    apd_rec(tadFD, txed_fsn, 128, RT_MFUSEN, 0, 0);
    fileLink.insert(std::pair<std::string, LINK>(cname, outlink));
  }
  
  bool first = true;
  do {
    W num, size;
    UH subtype;
    UB* buf = 0;
    
    type = fnd_rec(btmFD, (first ? F_FWD : F_NFWD),
                   0xffff0000 | RM_TADDATA, 0, &num);
    if (type >= 0){
      werr = rea_rec(btmFD, 0, NULL, 0, &size, &subtype);
      buf = new UB[size];
      werr = rea_rec(btmFD, 0, (B*)buf, size, NULL, NULL);
      
      werr = apd_rec(tadFD, NULL, 0, 1, 0, 0);
      werr = see_rec(tadFD, -1, -1, NULL);
      parseBtmData(tadFD, &outlink, buf, size);
      
      delete [] buf;
    }
    
    first = false;
  } while (type >= 0);
  
  werr = cls_fil(btmFD);
  werr = cls_fil(tadFD);
  
  return retlink;
}

int Btm2TAD::parseBtmData(W outFD, LINK *cur, UB* buf, int size)
{
  TC ch;
  
  int i = 0;
  while (i < size){
    if (buf[i] >= 0x80U && buf[i] <= 0xfe && buf[i+1] == 0xffU){
      // BTMemo
      BtmSegment* btm = reinterpret_cast<BtmSegment*>(&buf[i]);
      for (int j = 0; true; j++){
        TADSegment *tad = btm->createTADSegment(j);
        if (tad == 0){
          break;
        }
        wri_rec(outFD, -1, (B*)tad, tad->getSize(), NULL, NULL, 0);
        if (tad->isLinkSegment()){
          TC tname[512];
          char cname[1024];
          strcpy(cname, ((BtmLinkSegment*)btm)->link_body.szPath);
          // ȾѡѺƱΤᡢʲΥƥåפǰ
          sjstotcs(tname, (UB*)cname);
          trimPathAndExt(tname);
          tcstoeucs(cname, tname);
          // LinkSegmentѤ̽ɬ
          LINK outlink;
          std::map<std::string, LINK>::iterator p;
          p = fileLink.find(cname);
          if (p != fileLink.end()){
            // ˥ե뤬ƤϤ
            outlink = p->second;
          }
          else {
            outlink = *dest;
            W tadFD = cre_fil(&outlink, tname, NULL, 1, F_FLOAT);
            apd_rec(tadFD, txed_fsn, 128, RT_MFUSEN, 0, 0);
            cls_fil(tadFD);
            fileLink.insert(std::pair<std::string, LINK>(cname, outlink));
          }
          // outlink°򤤤
          int battr = ((BtmLinkSegment*)btm)->attr;
          ((VLINK*)&outlink)->attr = 0x000eU |
            ((BTATTR_OPEN & battr) ? 0x0100U : 0) |
            ((BTATTR_BORDER & battr) ? 0 : 0x0080U) |
            ((BTATTR_DRAWICON & battr) ? 0 : 0x0040U);
          
          // outlinkؤΥ󥯤Žդ
          W fd2 = opn_fil(cur, F_UPDATE, NULL);
          apd_rec(fd2, (B*)&outlink, sizeof(LINK), RT_LINK, 0, 0);
          cls_fil(fd2);
        }
        delete tad;
      }
      i += btm->getSize();
    }
    else if (buf[i] == 0xffU && buf[i+1] == 0xffU){
      // ü(֤󡣤ˤƤ̵)
      i += 2;
    }
    /*else if (buf[i] <= 0x1fU){
      // 楳(0̵롢1ϥѥǥɬפʤΤ)
      ;
    }
    else if ((buf[i] >= 0x81U && buf[i] <= 0x9eU) ||
             (buf[i] >= 0xe0U && buf[i] <= 0xefU)){
      // Shift-JIS Code
    }*/
    else {
      // Ⱦʸ(Ⱦѥʸޤ)
      //  + Shift-JIS + 楳
      int sw = sjtotc(&ch, &buf[i]);
      if (sw == 1 || sw == 2){
        i += sw; // ȾѥʤѴʤ
        printf("ch: %C\n", ch);
        wri_rec(outFD, -1, (B*)&ch, 2, NULL, NULL, 0);
      }
      else {
        // ѴǤʤä
        if (buf[i] != 0){
          printf("Unable to translate char %d.\n", buf[i]);
        }
        i++;
      }
    }
  }
  return 0;
}

COLOR Btm2TAD::transformColor(Windows32::COLORREF col)
{
  COLOR color = 0x10000000U | ((col & 0xffU) << 16)
    | (col & 0xff00U) | ((col & 0xff0000U) >> 16);
  return color;
}

void Btm2TAD::copyTADSegment(W srcFD, W destFD)
{
  W werr, num, size, type;
  UH subtype;
  B *buf;
  
  see_rec(srcFD, 0, 1, NULL); // Ƭ쥳ɤذư
  
  bool first = true;
  do {
    type = fnd_rec(srcFD, (first ? F_FWD : F_NFWD),
                   RM_TADDATA, 0, &num);
    if (type >= 0){
      // read from srcFD
      werr = rea_rec(srcFD, 0, NULL, 0, &size, &subtype);
      buf = new B[sizeof(B)*size];
      werr = rea_rec(srcFD, 0, buf, size, NULL, NULL);
      // write to destFD
      apd_rec(destFD, buf, size, type, subtype, 0);
      delete [] buf;
    }
    first = false;
  } while (type >= 0);
}

// werr = apd_rec(destFD, NULL, 0, 1, 0, 0);
// werr = see_rec(destFD, -1, -1, NULL);

void Btm2TAD::trimPathAndExt(TC *tcs)
{
  // ĥҤν
  int len = tc_strlen(tcs);
  int fnd = -1;
  for (int i = 0; i < len; i++){
    if (tcs[i] == L''){
      fnd = i;
    }
  }
  if (fnd >= 0){
    tcs[fnd] = TNULL;
    len = fnd;
  }
  
  // ѥν
  fnd = -1;
  for (int i = 0; i < len; i++){
    if (tcs[i] == L''){
      fnd = i;
    }
  }
  if (fnd >= 0){
    memmove(tcs, &tcs[fnd+1], (len-fnd)*sizeof(TC));
  }
}

void Btm2TAD::copyLinkAttr(const LINK* src, LINK* dest)
{
  dest->atr1 = src->atr1;
  dest->atr2 = src->atr2;
  dest->atr3 = src->atr3;
  dest->atr4 = src->atr4;
  dest->atr5 = src->atr5;
}

