// btm2tad version 0.100
//  BTMemoΥե뷲TADľС 
// (C)Copyright 2003, Yashiro Takeshi

// BtmSegment.cc : BTMemo

#include <bstring.h>
#include <stdio.h>

#include "BtmSegment.h"
#include "TADSegment.h"
#include "Btm2TAD.h"

TADSegment* BtmSegment::createTADSegment(int i)
{
  switch (id){
  case 0xffa0U:
    /*if (i == 0){
      printf("TADPagePaperSegment\n");
      TADPagePaperSegment *tseg = new TADPagePaperSegment;
      // sOrientationϤȤꤢ̵뤷Ƥ롣
      // [] ʸϳϥȤǲ٤0.1mmȤƤ
      tseg->length = ((BtmPageSegment*)this)->sPaperLength;
      tseg->width = ((BtmPageSegment*)this)->sPaperLength;
      tseg->top = ((BtmPageSegment*)this)->top / 10;
      tseg->bottom = ((BtmPageSegment*)this)->bottom / 10;
      tseg->left = ((BtmPageSegment*)this)->left / 10;
      tseg->right = ((BtmPageSegment*)this)->right / 10;
      return (TADSegment*)tseg;
    }
    else if (i == 1){
      printf("TADPageMarginSegment\n");
      TADPageMarginSegment *tseg = new TADPageMarginSegment;
      tseg->top = ((BtmPageSegment*)this)->top / 10;
      tseg->bottom = ((BtmPageSegment*)this)->bottom / 10;
      tseg->left = ((BtmPageSegment*)this)->left / 10;
      tseg->right = ((BtmPageSegment*)this)->right / 10;
      return (TADSegment*)tseg;
    }*/
    return 0;
  case 0xffa2U:
    if (i == 0){
      printf("TADFontSizeSegment\n");
      TADFontSizeSegment* tseg = new TADFontSizeSegment;
      // pixɡȤꤢݥȤȤȽ
      long tmp = ((BtmFontSegment*)this)->font.lfHeight;
      if (tmp < 0){
        tmp = -tmp;
      }
      else if (tmp == 0){
        tmp = 192; // 9.6pt
      }
      tseg->size = (tmp * 14) | 0x8000U;
      return (TADSegment*)tseg;
    }
    /*else if (i == 1){
      printf("TADFontSegment\n");
      TADFontSegment* tseg = new TADFontSegment;
      tseg->_class = ;
      // tseg->name[0]
      // tseg->len = 0x0004U; // name[]Ѥʤ
      return (TADSegment*)tseg;
    }
    else if (i == 2){
      printf("TADFontAttrSegment\n");
      TADFontAttrSegment* tseg = new TADFontAttrSegment;
      tseg->attr =;
      return (TADSegment*)tseg;
    }*/
    return 0;
  case 0xffa6U:
    if (i == 0){
      printf("TADTextColorSegment\n");
      TADTextColorSegment *tseg = new TADTextColorSegment;
      tseg->color = Btm2TAD::transformColor(((BtmTextColorSegment*)this)->col);
      return (TADSegment*)tseg;
    }
    return 0;
  case 0xffe0U:
    if (i == 0){
      printf("TADSegmentInfoSegment\n");
      return (TADSegment*)(new TADSegmentInfoSegment);
    }
    return 0;
  case 0xffe1U:
    if (i == 0){
      printf("TADTextSegment\n");
      return (TADSegment*)(new TADTextSegment);
    }
    return 0;
  case 0xffe2U:
    if (i == 0){
      printf("TADTextEndSegment\n");
      return (TADSegment*)(new TADTextEndSegment);
    }
    return 0;
  case 0xffe5U:
    printf("TADBitmapSegment, ignored.\n");
    return 0;
  case 0xffe6U:
    if (i == 0){
      printf("TADLinkSegment\n");
      TADLinkSegment *tseg = new TADLinkSegment;
      setrect(tseg->view, 0, 0, ((BtmLinkSegment*)this)->sizObject.cx*8/7 + 9,
              ((BtmLinkSegment*)this)->sizObject.cy*8/7);
      tseg->height = ((BtmLinkSegment*)this)->sizScroll.cy*8/7;
      tseg->chsz = 16; // Ȥꤢ
      tseg->frcol = 0x10000000U;
      tseg->chcol = 0x10000000U;
      tseg->tbcol = Btm2TAD::transformColor(((BtmLinkSegment*)this)->colBack);
      tseg->bgcol = 0x10ffffffU;
      return (TADSegment*)tseg;
    }
    return 0;
  default:
    printf("TADUnknownSegment, ignored.\n");
    return 0;
  }
  
  return 0;
}

